--[[

  CurseBar by Cilraaz of Archimonde/Cenarion Circle
  v2.4.0-0.1
  
  CurseBar is a modified version of AspectBar, which creates a row of buttons for a Warlock's curse spells
  
  As stated this is a modified version of AspectBar, by CRiSPyToWN
  
  Change Log:
  v2.4.0-0.1
  -- TOC Update for WoW 2.4
  -- Fixed CurseBar.xml to use Button instead of CheckButton to stop bad hilighting
  -- Also brought code cleanup over from SealBar
  v2.3.0-0.1
  -- Updated for WoW 2.3
  -- Added Amplify Curse and Curse of Exhaustion
  -- TOC Update
  v2.2.0-0.1
  -- Initial Release
    
]]--


CURSEBAR_ENABLED = true;

CurseBarData = { };

local Curses = {
AMP;
WEAKNESS;
AGONY;
RECKLESS;
TONGUES;
ELEMENTS;
IDIOCY;
SHADOW;
DOOM;
EXHAUST;
};

local CurseIcons = {
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
"INV_Misc_QuestionMark";
};

local ver = 24001;

local playerName, vBuffOn, vMounted, button;

function CurseBar_OnLoad()
	local _, Class = UnitClass("player");
	if (Class == "WARLOCK") then
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("SPELLS_CHANGED");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
	
  SLASH_CURSEBAR1 = "/cursebar";
	SlashCmdList["CURSEBAR"] = function(msg)
		CurseBar_SlashHandler(string.lower(msg));
	end
	end
end

function CurseBar_SlashHandler(msg)
	if (string.find(msg, "config")) then
		if( CurseBarConfig:IsVisible() ) then
      CurseBarConfig:Hide();
    else
      CurseBarConfig:Show();
    end
	elseif (string.find(msg, "help")) then
		DEFAULT_CHAT_FRAME:AddMessage("To configure type '/cursebar config'");
		DEFAULT_CHAT_FRAME:AddMessage("To move the bar: Left click and drag the bar's handle");
	else
		DEFAULT_CHAT_FRAME:AddMessage("Type '/cursebar help' for help");
	end
  --tinsert(UISpecialFrames,"CurseBarConfig"); 
end

function StartCurseBar()
	if (not CurseBarData) then
		CurseBarData[playerName] = {
			["horizontal"] = "true",
			["scale"] = 1,
			["amp"] = 1,
			["weakness"] = 1,
			["agony"] = 1,
			["reckless"] = 1,
			["tongues"] = 1,
			["elements"] = 1,
			["idiocy"] = 1,
			["shadow"] = 1,
			["doom"] = 1,
			["exhaust"] = 1,
			["version"] = ver,
			["hidebar"] = "false",
			["order"] = "az",
		};
	end
	if (not CurseBarData[playerName]) then
		CurseBarData[playerName] = {
			["horizontal"] = "true",
			["scale"] = 1,
			["amp"] = 1,
			["weakness"] = 1,
			["agony"] = 1,
			["reckless"] = 1,
			["tongues"] = 1,
			["elements"] = 1,
			["idiocy"] = 1,
			["shadow"] = 1,
			["doom"] = 1,
			["exhaust"] = 1,
			["version"] = ver,
			["hidebar"] = "false",
			["order"] = "az",
		};
	end 
	CURSEBAR_SCALE = 1;
	
	CurseBar_Scale();
	CurseBar_Update();
end

function FindPattern(text,pattern)
	return string.sub(text, string.find(text, pattern))
end

function CurseBar_OnEvent()
	if (event == "PLAYER_ENTERING_WORLD") then
		if (UnitName("player") ~= UNKNOWNBEING and UnitName("player") ~= UNKNOWNOBJECT and UnitName("player") and not playerName) then
			playerName = UnitName("player").." of "..GetCVar("realmName");
		end
		StartCurseBar();
	end
	if (event == "SPELLS_CHANGED" or event == "PLAYER_AURAS_CHANGED") then
		CurseBar_Update();
	elseif (event == "SPELL_UPDATE_COOLDOWN") then
		CurseBar_UpdateCooldowns();
	end
end

function CurseBar_Scale()
	for i = 1, 10 do
		button = getglobal("CurseBarButton"..i);
		button:SetScale(CurseBarData[playerName]["scale"]);
	end
end

function CurseBar_O()
	if (CurseBarData[playerName]) then
		if (not CurseBarData[playerName]["horizontal"]) then
			CurseBarData[playerName]["horizontal"] = "true"
			CurseBarData[playerName]["order"] = "az"			
		end
		
		-- New code for handle
		CurseBarHandleH:ClearAllPoints();
		CurseBarHandleH:SetAlpha(0);
		CurseBarHandleV:ClearAllPoints();
		CurseBarHandleV:SetAlpha(0);
		
		if (CurseBarData[playerName]["horizontal"] == "false" and CurseBarData[playerName]["order"] == "az") then
			for i = 2, 10 do
				local button = getglobal("CurseBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("TOP", "CurseBarButton"..i - 1, "BOTTOM", 0, 1);
			end
			CurseBarHandleH:SetPoint("TOP", "CurseBarButton1", "TOP", 0, 10);
			CurseBarHandleH:SetAlpha(1);
		elseif (CurseBarData[playerName]["horizontal"] == "false" and CurseBarData[playerName]["order"] == "za") then
			for i = 2, 10 do
				local button = getglobal("CurseBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("BOTTOM", "CurseBarButton"..i - 1, "TOP", 0, 1);
			end
			CurseBarHandleH:SetPoint("BOTTOM", "CurseBarButton1", "BOTTOM", 0, -10);
			CurseBarHandleH:SetAlpha(1);
		elseif (CurseBarData[playerName]["horizontal"] == "true" and CurseBarData[playerName]["order"] == "az") then
			for i = 2, 10 do
				local button = getglobal("CurseBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("LEFT", "CurseBarButton"..i - 1, "RIGHT", 1, 0);
			end
			CurseBarHandleV:SetPoint("LEFT", "CurseBarButton1", "LEFT", -10, 0);
			CurseBarHandleV:SetAlpha(1);
		elseif (CurseBarData[playerName]["horizontal"] == "true" and CurseBarData[playerName]["order"] == "za") then
			for i = 2, 10 do
				local button = getglobal("CurseBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("RIGHT", "CurseBarButton"..i - 1, "LEFT", 1, 0);
			end
			CurseBarHandleV:SetPoint("RIGHT", "CurseBarButton1", "RIGHT", 10, 0);
			CurseBarHandleV:SetAlpha(1);
		else
			for i = 2, 10 do
				local button = getglobal("CurseBarButton"..i);
				button:ClearAllPoints();
				button:SetPoint("LEFT", "CurseBarButton"..i - 1, "RIGHT", 1, 0);
			end
			CurseBarHandleV:SetPoint("LEFT", "CurseBarButton1", "LEFT", -10, 0);
			CurseBarHandleV:SetAlpha(1);
		end
	end
end

function CurseBar_Hide()
   local frame = getglobal("CurseBar");
   if (frame) then
     if(  frame:IsVisible() ) then
       frame:Hide();
     else
       frame:Show();
     end
   end
end

function CurseBar_Update()
	if (CurseBarData[playerName]) then
		CurseBar_O();
		i = 0;
		if (InCombatLockdown() == nil) then
			for key in pairs(Curses) do
				getglobal("CurseBarButton"..key):Hide();
			end
			CurseBar:Show();
		end
		for key, value in pairs(Curses) do
			local id = CurseBar_GetSpellID(value);
			if (id) then
				i = i + 1;
  				button = getglobal("CurseBarButton"..i);
				if (InCombatLockdown() == nil) then
					button:SetAttribute("type", "spell");
					button:SetAttribute("spell", value);
				end
  				local texture = GetSpellTexture(id, BOOKTYPE_SPELL);
  				getglobal("CurseBarButton"..i.."Icon"):SetTexture(texture);
  				button:SetAttribute("id",id);
				if (InCombatLockdown() == nil) then
	  				button:Show();
				end
			end
		end
		if ((i == 0) and (InCombatLockdown() == nil)) then
			CurseBar:Hide();
		end
	end
end

function CurseBar_UpdateCooldowns()
	for i = 1, 10 do
		button = getglobal("CurseBarButton"..i);
		if (button:GetAttribute("id")) then
			local cooldown = getglobal(button:GetName().."Cooldown");
			local start, duration, enable = GetSpellCooldown(button:GetAttribute("id"), SpellBookFrame.bookType);
			if (start > 0 and duration > 0 and enable > 0) then
				cooldown:SetCooldown(start, duration);
			end
		end
	end
end

function CurseBar_GetSpellID(spell, rank, debug)
	local i = 1;
	local spellID;
	local highestRank;
	while true do
		local spellName, spellRank = GetSpellName(i, SpellBookFrame.bookType);
		if (not spellName) then
			break;
		end
		if (spellName == spell) then
			if (rank) then
				if (spellRank == rank) then
					if (debug) then
						DEFAULT_CHAT_FRAME:AddMessage("Found |cffffffff'"..spell.." ("..rank..")'|r at slot |cffffffff'"..i.."'", 0.1, 1.0, 0.0);
					end
					return i;
				end
			else
				spellID = i;
				highestRank = spellRank;
			end
		end
		i = i + 1;
		if (i > 250) then
			break;
		end
	end			
	if (debug) then
		DEFAULT_CHAT_FRAME:AddMessage("Could not find |cffffffff'"..spell.." ("..rank..")'", 1.0, 0.1, 0.0);
	end
	return spellID, highestRank;
end

function CurseBar_SetTooltip()
	if (this:GetAttribute("id")) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
		GameTooltip:SetSpell(this:GetAttribute("id"), SpellBookFrame.bookType);
		GameTooltip:Show();
	end
end

function CurseBar_OnClick()
	if (this:GetAttribute("id") and arg1 == "LeftButton") then
  		CastSpell(this:GetAttribute("id"), BOOKTYPE_SPELL);
	end
end

function CurseBar_OnBind(that_spell)
  local spellID = CurseBar_GetSpellID(that_spell);
	CastSpell(spellID, BOOKTYPE_SPELL);
end

function CurseBarGetPoint()
	local vLeft = CurseBar:GetLeft();
	local vTop = CurseBar:GetTop();
	CurseBarData[playerName]["left"] = vLeft;
	CurseBarData[playerName]["top"] = vTop;
	--DEFAULT_CHAT_FRAME:AddMessage(vLeft.." "..vTop);
end


-- CONFIG

-- OnShow
function CurseBarConfig_OnShow()
	if (not CurseBarData) then
		this:Hide();
		return;
	end
	if (not CurseBarData[playerName]) then
		this:Hide();
		return;
	end
	if (not CurseBarData[playerName]["weakness"]) then
		this:Hide();
		return;
	end

	local vSlider = getglobal(this:GetName().."SliderScale");
	vSlider:ClearAllPoints();
	vSlider:SetPoint("TOPLEFT", "CurseBarConfigCheckButton1", "TOPLEFT", 0, -40);
	
	getglobal(this:GetName().."SliderScale"):SetValue( CurseBarData[playerName]["scale"] );
	getglobal(this:GetName().."CheckButton1"):SetChecked(CurseBarData[playerName]["horizontal"]);

end

function CurseBarConfigScale_OnClick()
	CurseBarData[playerName]["scale"] = this:GetValue();
	CurseBar_Scale();
end

function CurseBarConfigCheckBoxHide_OnClick()
	if (CurseBarData[playerName]["hidebar"] == "true") then
		CurseBarData[playerName]["hidebar"] = "false";
	else
		CurseBarData[playerName]["hidebar"] = "true";
	end
	CurseBar_Hide();
end

function CurseBarConfigCheckBox_OnClick()
	if (CurseBarData[playerName]["horizontal"] == "true") then
		CurseBarData[playerName]["horizontal"] = "false";
	else
		CurseBarData[playerName]["horizontal"] = "true"
	end
	CurseBar_O();
end

function CurseBarConfigCheckBoxOrder_OnClick()
	if (CurseBarData[playerName]["order"] == "az") then
		CurseBarData[playerName]["order"] = "za";
	else
		CurseBarData[playerName]["order"] = "az"
	end
	CurseBar_O();
end
